/*******************************************************
 * LX Midi Beep player LXMIDI.EXE                      *
 *           Copyright (C) 1996 HARUYA                 *
 *           Compiled by Turbo-C V2.0                  *
 * Ver 1.0   1996/08/15                                *
 * Ver 1.10  1996/08/17 Bender,Portament           *
 * Ver 1.11  1996/08/18 yɂăL[Vtg       *
 *                      9dȏ̘aw肳ꂽƂ*
 *                      ⏈ύX                 *
 * Ver 1.20  1996/08/21 hZbg(STD)t(n)    *
 *                      filename.MIDȗ\       *
 *                      all note offsSoO *
 *                      ̑̃oOFIX          *
 * Ver 1.21  1996/08/25 expressioñoOFIX      *
 *                      tempo adj,transposeIvV  *
 * Ver 1.22  1996/08/27 ⏈                 *
 *                      reverb levelIvVǉ     *
 * Ver 1.23  1996/08/27 ⏈                 *
 *                      running statusmeta eventŌ *
 *                      삷oOFIX              *
 * ver 1.30  1996/09/01 nOAbvoOFIX          *
 *                      volumeœK@\     *
 *                      tꎞ~@\         *
 *                      pitch modulation     *
 *                      tIVXev␳ *
 *                      悤ɂB                 *
 * ver 1.40  1996/09/07 ő16         *
 *                      Ver 1.30ŔIBMPC\oO*
 *                      FIX (getch̎gp)      *
 *                      eF̉ʂ𒲐             *
 * ver 1.41  1996/09/21 tɓtXVȂoO *
 *                      ƁAI㎞vȂ邱 *
 *                      ƂoOCB           *
 *******************************************************/

#include<ctype.h>
#include<io.h>
#include<dos.h>
#include<string.h>
#include<stdlib.h>
#include<stdio.h>
#include<process.h>


extern void settable(unsigned int , unsigned int);
extern void pcmstart(unsigned int , int , int);
extern void pcmstop(int);
extern int  playseq(unsigned int * , unsigned int , int);
extern void displayoff(void);
extern void displayon(void);
extern void waitempty(void);
extern int mykbhit(void);
extern int mygetch(void);
extern void pc98patch(void);
extern void pcmstart98(unsigned int , int);
extern void pcmstop98(void);


unsigned char chvol[16]={		/* ch volume */
	100,100,100,100,100,100,100,100,
	100,100,100,100,100,100,100,100};

unsigned char chexp[16]={		/* ch expresson */
	127,127,127,127,127,127,127,127,
	127,127,127,127,127,127,127,127};

unsigned long tonebase[48]={	/* tone base table */
	0x20b404a1,0x212dcab9,0x21a95641,0x2226add2,
	0x22a5d81c,0x2326dbe9,0x23a9c01d,0x242e8bb4,
	0x24b545c7,0x253df583,0x25c8a238,0x2655534b,
	0x26e41040,0x2774e0b4,0x2807cc64,0x289cdb27,
	0x293414f2,0x29cd81d7,0x2a692a09,0x2b0715d6,
	0x2ba74dac,0x2c49da18,0x2ceec3c9,0x2d96138c,
	0x2e3fd24f,0x2eec0922,0x2f9ac138,0x304c03e4,
	0x30ffda9c,0x31b64ef9,0x326f6abb,0x332b37c1,
	0x33e9c015,0x34ab0ddf,0x356f2b73,0x36362349,
	0x37000000,0x37cccc5e,0x389c9353,0x396f5ff6,
	0x3a453d88,0x3b1e3774,0x3bfa594f,0x3cd9aed9,
	0x3dbc4400,0x3ea224da,0x3f8b5daf,0x4077faf1};


int pgmtbl[128][4]=		/* program table env,vol/8,sft,pitcpx */
   {{ 0,7,  0,0},{ 0,7,  0,0},{ 0,7,  0,0},{ 0,7,  0,0}, /* 0-3 */
	{ 0,7,  0,0},{ 0,7,  0,0},{ 0,7,  0,0},{ 0,7,  0,0}, /* 4-7 */
	{ 0,7,  0,0},{ 0,7, 12,0},{ 0,7,  0,0},{ 0,7,  0,0}, /* 8-11 */
	{ 1,7,  0,0},{ 1,7,  0,0},{ 0,7,  0,0},{ 1,7,  0,0}, /* 12-15 */
	{ 6,7,  0,0},{ 6,7,-12,0},{ 6,7,-12,0},{ 6,8,  0,0}, /* 16-19 */
	{ 6,8,  0,0},{ 6,8,  0,0},{ 6,8,  0,0},{ 6,8,  0,0}, /* 20-23 */
	{ 2,7,  0,0},{ 2,7,  0,0},{ 0,7,  0,0},{ 0,7,  0,0}, /* 24-27 */
	{23,8,  0,0},{ 6,8,  0,0},{ 6,8,  0,0},{23,8, 12,0}, /* 28-31 */
	{ 0,7,  0,0},{ 0,7,  0,0},{ 6,7,  0,0},{ 6,7,  0,0}, /* 32-35 */
	{ 6,7,  0,0},{ 6,7,  0,0},{ 0,7,  0,0},{ 0,7,  0,0}, /* 36-39 */
	{ 3,7,  0,0},{ 3,7,  0,0},{ 3,7,  0,0},{ 3,7,  0,0}, /* 40-43 */
	{ 3,5,  0,0},{ 1,7,  0,0},{ 2,6,  0,0},{ 2,6,  0,0}, /* 44-47 */
	{ 3,7,  0,0},{ 4,7,  0,0},{ 3,7,  0,0},{ 3,7,  0,0}, /* 48-51 */
	{ 3,7,  0,0},{ 5,7,  0,0},{ 3,7,  0,0},{ 1,8,-12,0}, /* 52-55 */
	{ 5,7,  0,0},{ 5,7,  0,0},{ 5,7,  0,0},{ 5,7,  0,0}, /* 56-59 */
	{ 3,7,  0,0},{ 5,7,  0,0},{ 5,7,  0,0},{ 5,7,  0,0}, /* 60-63 */
	{ 6,7,  0,0},{ 5,7,  0,0},{ 5,7,  0,0},{ 5,7,  0,0}, /* 64-67 */
	{ 5,6,  0,0},{ 3,7,  0,0},{ 5,7,  0,0},{ 5,7,  0,0}, /* 68-71 */
	{ 6,7,  0,0},{ 6,7,  0,0},{ 6,7,  0,0},{ 6,7,  0,0}, /* 72-75 */
	{ 6,7,  0,0},{ 6,7,  0,0},{ 3,7,  0,0},{ 6,7,  0,0}, /* 76-79 */
	{ 6,7,  0,0},{ 6,7,  0,0},{ 6,7,  0,0},{ 6,7,  0,0}, /* 80-83 */
	{ 6,7,  0,0},{ 6,7,  0,0},{ 6,7,  0,0},{ 6,7,  0,0}, /* 84-87 */
	{ 6,7,  0,0},{ 4,7,  0,0},{ 5,7,  0,0},{ 6,7,  0,0}, /* 88-91 */
	{ 6,7,  0,0},{ 4,7,  0,0},{ 6,7,  0,0},{ 4,7,  0,0}, /* 92-95 */
	{ 0,7,  0,0},{ 3,7,  0,0},{ 2,7,  0,0},{ 0,7,  0,0}, /* 96-99 */
	{ 0,7,  0,0},{ 3,7,  0,0},{ 3,7,  0,0},{ 3,7,  0,0}, /* 100-103 */
	{ 0,7,  0,0},{ 2,7,  0,0},{23,7,  0,0},{ 2,7,  0,0}, /* 104-107 */
	{23,7,  0,0},{ 5,7,  0,0},{ 6,7,  0,0},{ 6,7,  0,0}, /* 108-111 */
	{ 1,7, 10,0},{19,7,  8,0},{ 1,7,  0,0},{19,7,  0,1}, /* 112-115 */
	{10,7,-24,1},{11,7,-12,1},{12,7,  0,1},{13,7, 48,1}, /* 116-119 */
	{14,3,  0,0},{15,3,  0,0},{ 8,0,  0,0},{ 8,0,  0,0}, /* 120-123 */
	{ 8,0,  0,0},{ 8,0,  0,0},{ 8,0,  0,0},{ 8,0,  0,0}}; /* 124-127 */ 

int envtbl[]={ /* envelope tablle   flag,vol,delay,vol,delay,...,vol,0,2 */
	1,8, 15,6, 30,4, 45,2, 80,1,160,0,-1,		/* 0 :piano */
	1,8,  5,6, 10,4, 15,2, 30,1, 60,0,-1,		/* 1 :marinba */
	1,8, 10,6, 20,4, 30,2, 50,1,100,0,-1,		/* 2 :guitar */
	0,4,  2,6,  4,8, -1,						/* 3 :violin */
	0,4, 15,6, 30,7, 45,8,-1,					/* 4 :slow */
	0,4,  3,8,  5,7, -1,						/* 5 :trumpet */
	0,5,  3,8,-1,								/* 6 :organ */
	0,8, -1,									/* 7 :flat */
	0,0, -1,									/* 8 :silent */

	0,9,  2,5,     4,3,     6,2,     8,0,-1,	/* 9:Short Hit */
	0,9,  5,5,    10,3,    15,2,    20,0,-1,	/* 10:Long Hit */
	2,9,  3,6, 0,  6,4,-1,  9,2,-2, 12,0,0,-1,	/* 11:Tom */
	2,9,  3,6,-1,  6,4,-2,  9,2,-3, 12,0,0,-1,	/* 12:Syn Tom */
	0,4, 25,5,    50,6,    75,8,   100,0,-1,	/* 13:rev syn */
	0,3,  1,6,     3,8,     4,6,    25,0,-1,	/* 14:scratch */
	0,5,  2,7,     3,8,     4,5,     5,0,-1,	/* 15:hat-env */
	0,8,  2,5,     3,3,     4,2,     5,0,-1,	/* 16:Short Hit */
	0,8,  2,5,     5,3,     7,2,    10,0,-1,	/* 17:Midium Hit */
	0,8,  5,5,    10,3,    15,2,    20,0,-1,	/* 18:Long Hit */
	0,8,  1,5,     2,3,     3,2,     4,0,-1,	/* 19:Bit Hit */
	0,5,  1,3,     2,2,     3,1,     4,0,-1,	/* 20:Bit Hit Small */
	0,5,  5,3,    10,2,    15,1,    20,0,-1,	/* 21:Long Hit Small */
	2,8,  4,10,12,13,4,12, 15,2,12, 17,0,0,-1,	/* 22: Woo! */
	1,8,  5,5,    15,3,    30,2,    50,1,100,0,-1, /* 23: Muted Guter */
	-2};

#define ENV9	67		/* pointer of flat enverope */

int drum[61][2]=	/* drum set table {key,env} */
	{{45 ,16},{4,17},{107,12},
	 {102,12},{100,19},{ 36,19},{ 41,16},{108,18},{ 47, 9},
	 { 48, 9},{  4,19},{  4,10},{  4,15},{  4, 9},{ 52,11}, /* C2 */
	 {  4,20},{ 55,11},{  4,20},{ 59,11},{  4,21},{ 62,11},
	 { 64,11},{  4,10},{ 66,11},{108,16},{  4,18},{103,17}, /* C3 */
	 {104,16},{105,17},{ 59,19},{  4,18},{ 59,14},{107,16},
	 { 53,19},{ 51,19},{ 77,19},{ 61,16},{ 56,16},{ 54, 9}, /* C4 */
	 { 48,10},{ 89,16},{ 84,17},{108,15},{107,19},{ 98,15},
	 { 95,14},{ 38,15},{ 26,11},{ 97,16},{ 68,19},{ 64,19}, /* C5 */ 
	 { 60,22},{ 36,22},{103,19},{103,18},{  4,19},{ 91,17},
	 {101,12},{103,16},{ 50,19},{ 38,10}};

int modtbl[4][8]=	/* pitch modulation depth table */
	{{ 0, 0, 1, 1, 0, 0, 0, 0},
	 { 1, 1, 1, 1, 0, 0, 0, 0},
     { 0, 0, 1, 1, 0, 0,-1,-1},
	 { 0, 1, 1, 1, 0,-1,-1,-1}};

int	env[16]		 	= {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int	bendrange[16]	= {8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8};
int	lastkey[16]	 	= {60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60};
char hold[16]	 	= {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char pitbend[16] 	= {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char portament[16]	= {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char shift[16]		= {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char pitcpx[16]		= {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char chmodl[16]		= {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char pgmvol[16]		= {8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8};
char mask[17]={"                "};	/* MIDI channel mask */

unsigned char portmap[16][6];		/* port mapping reg. */
									/* ch,tone,truetone,seq,vol,truevol */
int timing[256][4];					/* timing stack:delay,port,tone,vol */
unsigned char holdflg[16][128];
unsigned int  workseg[10];

unsigned long basefreq=2000000;	/* master clock (18MHz) */
unsigned long tempo   =500000;	/* tempo=500ms/quarter */
unsigned int intperiod=95;		/* interrupt period */
int	tmpadj=100;					/* tempo adjust (%) */
int	keyadj=0;					/* key adjust (tone) */
int	drumadj=100;				/* drum vol adjust (%) */

int	timptr=0;						/* timing stack */

int	portmax=11;
int	melodymin=0;

int	envoff=0;
int	segnmax,segn;
unsigned char far *datap;
unsigned long convrate;
unsigned int vol;
unsigned char seqhis=0;
int chmodpor=0,lfocnt=0,lfo=0,lfoerr=0,volsmp=0,peakvol=0;
int yhist1=0,yhist2=0;

void resetenv(int);
int pbconv(int pbend,int *cmd);


/* get heap memory */

int	getmem(void){
	int	n=0;
	while ((allocmem(4096,&workseg[n]))==-1){
		n++;
	}
	workseg[n]=0;
	return n;
}


/* release heap memory */

void relmem(void){
	int	i=0;
	while(workseg[i]!=0){
		freemem(workseg[i]);
		i++;
	}
}


/* send data to seq buf */

int	send0(int deltatime,int port,int key,int volm){
	if (volm>63) volm=63;
	if (deltatime>16383) deltatime=16383;
	deltatime=(deltatime<<1)+(port>>3);
	if ( deltatime >= 0x80 ){
		*datap=(unsigned char) (deltatime | 0x80);
		datap++;
		*datap=(unsigned char) (deltatime >> 7);
		datap++;
	}else{
		*datap=(unsigned char) deltatime;
		datap++;
	}
	*datap=(unsigned char)((volm<<3)+(port&7));
	datap++;
	*datap=(unsigned char)((key<<1)+(volm>>5));
	datap++;

	if ( FP_OFF(datap) > 0xfff0){
		*datap=0x00;datap++;
		*datap=0xff;datap++;
		*datap=0xff;
		
		if (segn == segnmax){
			datap=(unsigned char far*)((unsigned long)(workseg[segn])<<16)+0Xffef;			return 1;
		}else{
			segn++;
			datap=(unsigned char far*)((unsigned long)(workseg[segn])<<16);
		}
	}
	return 0;
}


/* send data with pitch modulate execution */

int	send(int deltatime,int port,int key,int volm)
{
	int i,j,k,l,x,y,pbend,pb,cmd,f=0;
	while ((j=deltatime-lfocnt)>=0){
		if ((volsmp++)>15){
			volsmp=0;
			y=0;
			for (x=0;x<=portmax;x++){
				if (portmap[x][0]>0) y+=(portmap[x][5]*chexp[portmap[x][0]-1]+64)>>7;
			}
			x=(y+yhist1+yhist2)/3;
			if (peakvol<x) peakvol=x;
			yhist2=yhist1;
			yhist1=y;
		}
		for (i=0;i<=portmax;i++){
			if ((k=portmap[i][0])>0){
				f=1;				
				if ((l=chmodl[k-1])>0){
					pbend=pitbend[k-1]+modtbl[min(l-1,3)][chmodpor];
					pb=pbconv(pbend,&cmd);
					send0(lfocnt,i,cmd,pb);
					deltatime=j;
					lfocnt=0;
				}
			}
		}
		lfocnt+=lfo>>4;
		lfoerr+=lfo&15;
		if (lfoerr>16){
			lfoerr-=16;
			lfocnt++;
		}
		if ((chmodpor++)>7) chmodpor=0;
		if (f==0) chmodpor=0;
	}
	lfocnt-=deltatime;
	return send0(deltatime,port,key,volm);
}


/* send data with expression execution*/

int	send1(int deltatime,int port,int key,int volm){
	int v=0;
	if (volm!=0) v=((int)volm*chexp[portmap[port][0]-1]+64)>>7;
	return send(deltatime,port,key,v);
}


/* envelope event execution */

int	execenv(int deltatime){
	int	i,j,port,truekey,volm;
	int *ptr;
	int rel[16];
	if (deltatime>0){
		for(i=0;i<=portmax;i++) rel[i]=0;
		for(i=timptr-1;i>=0;i--){
			ptr=(int *)timing[i];
			if ((j=deltatime-*ptr)<0){
				*ptr-=deltatime;
				break;
			}
			deltatime=j;
			port=*(ptr+1);
			truekey=*(ptr+2);
			volm=*(ptr+3);
			if (truekey<4){
				send(*ptr,port,truekey,volm);
			}else{
				if (volm==0){
					if (portmap[port][5]>0){
						truekey=127;
						rel[port]=1;
					}
				}
				send1(*ptr,port,truekey,volm);
				portmap[port][2]=truekey;
				portmap[port][5]=volm;
			}
		}
		timptr=i+1;
		for(i=0;i<=portmax;i++){
			if	(rel[i]){
				portmap[i][0]=0;
				resetenv(i);
			}
		}
	}
	return deltatime;
}


/* Read Variable-length-value (SMF Numeral Format) */

unsigned long ReadVarLen (FILE *fp)
{
	unsigned long value=0;
	unsigned char c;
	int	j;
	if ((value = getc(fp)) & 0x80){
		value &= 0x7f;
		for(j=0;j<3;j++){
			value = (value << 7) + ((c = getc(fp)) & 0x7f);
			if ((c & 0x80)==0) break;
		}
	}
	return (value);
}


/* Read 4bytes (little endian) */

unsigned long ReadLong (FILE *fp)
{
	unsigned long value=0;
	int	i;
	for (i=0;i<4;i++){
		value=(value<<8)+(unsigned char)getc(fp);
	}
	return (value);
}


/* Read 3bytes (little endian) */

unsigned long ReadSemiLong (FILE *fp)
{
	unsigned long value=0;
	int	i;
	for (i=0;i<3;i++){
		value=(value<<8)+(unsigned char)getc(fp);
	}
	return (value);
}


/* Read 2bytes (little endian) */

unsigned int ReadWord (FILE *fp)
{
	unsigned int value=0;
	int	i;
	for (i=0;i<2;i++){
		value=(value<<8)+(unsigned char)getc(fp);
	}
	return (value);
}


/* calculate tempo convertion ratio (convrate/0xfff) */

void temposet(unsigned long tmp,unsigned int div)
{
	convrate=(unsigned long)(
			((tmp>>6)*100/tmpadj) * (((unsigned long)(basefreq)<<10)/1000000)
			/ ((unsigned long)(div)*intperiod) );
}


/* insert to enverope order stack */

void setenv(int deltatime,int port,int key,int volume){
	int	i,j;
	int	*ptr;
	if (deltatime==0) return;
	for(i=timptr-1;i>=0;i--){
		if ((j=deltatime-timing[i][0])<0){
			timing[i][0]-=deltatime;
			break;
		}
		deltatime=j;
		ptr=(int *)timing[i];
		*(ptr+4)=*ptr;
		*(ptr+5)=*(ptr+1);
		*(ptr+6)=*(ptr+2);
		*(ptr+7)=*(ptr+3);
	}
	ptr=(int *)timing[i+1];
	*ptr=deltatime;
	*(ptr+1)=port;
	*(ptr+2)=key;
	*(ptr+3)=volume;
	timptr++;


	if (timptr>255) {
		timptr=255;
		printf("Envelope stack overflow!\n");
	}
}


/* delete from enverope order stack */

void resetenv(int port){
	int	i,j;
	int *ptr;
	i=0;
	while (i<timptr){
		if (timing[i][1]==port){
			if (i!=0) timing[i-1][0]+=timing[i][0];
			ptr=(int *)timing[i];
			for (j=i;j<timptr-1;j++){
				*ptr    =*(ptr+4);
				*(ptr+1)=*(ptr+5);
				*(ptr+2)=*(ptr+6);
				*(ptr+3)=*(ptr+7);
				ptr+=4;
			}
			timptr--;
		}else{
			i++;
		}
	}
}


/* make pitch bend command */

int pbconv(int pbend,int *cmd){
	int	res;
	if (pbend>=64){
		*cmd=1;
		res=pbend-64;
	}else if (pbend>=0){
		*cmd=0;
		res=pbend;
	}else if (pbend>-64){
		*cmd=2;
		res=-pbend;
	}else{
		*cmd=3;
		res=-pbend+64;
	}
	if (res>63) res=63;
	return(res);
}


/* key on */

void keyon(int delta,int port,int truekey,int volume,int envptr,int ch){	
	int p,r,cmd,pb,i,j,k,l,m,pbend,por,lstkey,v;
	pbend=pitbend[ch]; /* pitch bend flag */
	por=portament[ch]; /* portament flag */
	lstkey=lastkey[ch]; /* last note */

	v=volume*envtbl[envptr+1];
	v=(v+4)>>3;
	portmap[port][5]=v;
	send1(delta,port,truekey,v); /* key on */

	if (pbend){
		pb=pbconv(pbend,&cmd);
		send(0,port,cmd,pb); /* pitch bend */
	}
	if (por) {
		k=(lstkey-truekey)*12/16+pbend;
		m=0;
		pb=pbconv(k,&cmd);
		send(0,port,cmd,pb);
		for (i=1;i<10;i++){
			j=(lstkey-truekey)*(9-i)/16+pbend;
			l=por*i/9;
			if ((j!=k)&&(l!=m)) {
				pb=pbconv(j,&cmd);
				setenv(l,port,cmd,pb);
				k=j;
				m=l;
			}
		}
	}
	switch (envtbl[envptr]){
	  case 1:
		r=truekey/24;
		envptr+=2;
		while ((p=envtbl[envptr])>=0){
			p=((unsigned int)p<<2)>>r;
			v=volume*envtbl[envptr+1];
			if (v!=0) v=(v+4)>>3;
				if (p!=0){
				setenv(p,port,truekey,v);
			}else{
				portmap[port][5]=v;
				send1(0,port,truekey,v);
			}
			envptr+=2;
			if (v==0) break;
		}
		break;
	  case 2:
		envptr+=2;
		while ((p=envtbl[envptr])>=0){
			v=volume*envtbl[envptr+1];
			if (v!=0) v=(v+4)>>3;
			if (p!=0){
				setenv(p,port,truekey+envtbl[envptr+2],v);
			}else{
				portmap[port][5]=v;
				send1(0,port,truekey+envtbl[envptr+2],v);
			}
			envptr+=3;
			if (v==0) break;
		}
		break;
	  default:
		envptr+=2;
		while ((p=envtbl[envptr])>=0){
			v=volume*envtbl[envptr+1];
			if (v!=0) v=(v+4)>>3;
			if (p!=0){
				setenv(p,port,truekey,v);
			}else{
				portmap[port][5]=v;
				send1(0,port,truekey,v);
			}
			envptr+=2;
			if (v==0) break;
		}
	}
}

/* beep sound port assign */

int	portassign(int deltatime,char ch,char key,char truekey,int volume){
	int i,j,same=-1,free=-1,envptr,age=0;
	int mostold=0;
	envptr=env[ch];
	/* ch */
	if (ch==9){
		same=0;
		melodymin=1;
	}else{
		for (i=melodymin;i<=portmax;i++){
			if (portmap[i][0]==ch+1){
				if (portmap[i][2]==truekey) {
					same=i; /* chœ */
					break;
				}
			}
			if (portmap[i][0]==0) free=i; /* 󂫃|[giő̂̂{ */
		}
	}
	if (same>=0){		/* chœkey */
		if (ch==9){
			if ((portmap[same][0]>0)&&(portmap[same][2]==4)&&(deltatime==0)){
				if (truekey!=4) return deltatime;
				if (portmap[same][4]>volume) return deltatime;
			}
		}
		portmap[same][0]=ch+1;
		portmap[same][1]=key;
		portmap[same][2]=truekey;
		portmap[same][3]=seqhis;
		portmap[same][4]=volume;
		seqhis++;
		send(deltatime,same,127,     0); /* key off */
		resetenv(same);
		keyon(0,same,truekey,volume,envptr,ch); /* key on */
		deltatime=0;
		return deltatime;
	}
	if (free>=0){  /* 󂫃|[g */
		portmap[free][0]=ch+1;
		portmap[free][1]=key;
		portmap[free][2]=truekey;
		portmap[free][3]=seqhis;
		portmap[free][4]=volume;
		seqhis++;
		keyon(deltatime,free,truekey,volume,envptr,ch); /* key on */
		deltatime=0;
		return deltatime;
	}

	/* 󂫃|[gȂ */
	/* ԏĂȅȂȉT */
	j=portmax;
	for (i=melodymin;i<=portmax;i++){
		age=min((unsigned char)(seqhis-portmap[i][3]-1),(portmax+1));
		age+=(127-portmap[i][2])>>5;	/* tone  influence:4 */
		age+=64-(portmap[i][4]<<5)/vol;	/* vol influence:32 */
		if (portmap[i][2]==truekey) age+=24;
		if (portmap[i][0]==ch+1)	age+=28;
		if (age>=mostold){
			mostold=age;
			j=i;
		}
	}
	portmap[j][0]=ch+1;
	portmap[j][1]=key;
	portmap[j][2]=truekey;
	portmap[j][3]=seqhis;
	portmap[j][4]=volume;
	seqhis++;
	send(deltatime,j,127,     0); /* key off */
	deltatime=0;
	resetenv(j);
	keyon(0        ,j,truekey,volume,envptr,ch); /* key on */
	return deltatime;
}


/* beep sound port release */

int	portfree(int deltatime,char ch,char key){
	int i;
	for (i=0;i<=portmax;i++){
		if (portmap[i][1]==key){
			if (portmap[i][0]==ch+1){
				portmap[i][0]=0;
				send(deltatime,i,127,0); /* key off */
				deltatime=0;
				resetenv(i);
				break;
			}
		}
	}
	return deltatime;
}


/* all note off */

int	allnoteoff(int deltatime,char ch){
	int i;
	for (i=0;i<=portmax;i++){
		if (portmap[i][0]==ch+1){
			portmap[i][0]=0;
			send(deltatime,i,127,0); /* key off */
			resetenv(i);
			deltatime=0;
		}
	}
	return deltatime;
}


/* real time pitch bend execution */

int	realbend(int deltatime,char ch,int pbend){
	int i,cmd,pb;
	for (i=0;i<=portmax;i++){
		if (portmap[i][0]==ch+1){
			pb=pbconv(pbend,&cmd);
			send(deltatime,i,cmd,pb); /* pitch bend */
			deltatime=0;
		}
	}
	return deltatime;
}


/* execute real time expression */

int	realexp(int deltatime,char ch){
	int	i;
	for (i=0;i<=portmax;i++){
		if (portmap[i][0]==ch+1){
			send1(deltatime,i,portmap[i][2],portmap[i][5]);
			deltatime=0;
		}
	}
	return deltatime;
}


/* note off */

int noteoff(int deltatime,char ch,char key){
	if (hold[ch]){
		holdflg[ch][key]=1;
	}else{
		deltatime=portfree(deltatime,ch,key);
	}
	return deltatime;
}

/* dumper off */
int dumperoff(int deltatime,char ch){
	int i;
	for(i=0;i<128;i++){
		if (holdflg[ch][i]){
			deltatime=portfree(deltatime,ch,i);
			holdflg[ch][i]=0;
		}
	}
	return deltatime;
}


/* analize SMF file and convert to beep seq. data */

int	smfconv(FILE *fp){
	char strbuf[256];
	int d;
	unsigned int div,cnt=0;
	int	deltatime=0;
	unsigned long delta,time=0,size,v1;
	char pgm,key,truekey,vel,ch,cmd,arg,cmdhis=0x80;
	int	i,j,pbh,pbl,pb,f;
	int	endmark=0,volume,portamenttime=0;
	int	rpch[16],rpcl[16],envno[64];

	/* recalc & headsearch envelope table */
	i=0;
	j=0;
	while ((f=envtbl[i])!=-2){
		envno[j++]=i;
		i+=2;
		while (envtbl[i]!=-1){
			envtbl[i]=((((long)(envtbl[i])*(basefreq/intperiod))>>13)+1)>>1;
			if (f==2) i+=3; else i+=2;
		}
		i++;
	}

	/* check SMF Header */
	fgets(strbuf,5,fp);
	if (strcmp(strbuf,"MThd")!=0)	return 1;
	if (ReadLong(fp)!=6)		return 1;
	if (ReadLong(fp)!=1)		return 2;
	div=ReadWord(fp);
	temposet(tempo,div);
	fgets(strbuf,5,fp);

	/* check SMF Data */
	if (strcmp(strbuf,"MTrk")!=0)	return 1;
	ReadLong(fp);	/* ignore track length */

	while(endmark==0){
		if ((cnt++)>=256){
			cnt=0;
			putchar('.');
			if (mykbhit()) return 4; /* use break */
		}
		delta=ReadVarLen(fp);
		time+=delta*convrate;
		deltatime=min(0x3fff,(unsigned int)deltatime+(unsigned int)(time>>12));
		time=time & 0xfff;

		deltatime=execenv(deltatime); /* envelope operation */

		d=getc(fp);
		if (d == EOF) return 5;
		if (d < 0x80){	/* running sequence */
			key=d;
			d=cmdhis;
		}else{
			key=getc(fp);
			if ((d != 0xf0) && (d != 0xf7) && (d != 0xff)) cmdhis=d;
		}
		ch=d & 0x0f; /* MIDI ch 0-15 */
		switch (d & 0xf0){

		  case 0x80:	/* key off */
			vel=getc(fp);
			if (mask[ch]=='M') break;
			if (ch==9) break;
			if ((key<5)||(key>126)) break;
			deltatime=noteoff(deltatime,ch,key);
			break;

		  case 0x90:	/* key on */
			vel=getc(fp);
			if ((key<5)||(key>126)) break;
			if (mask[ch]=='M') break;
			v1=((unsigned long)(vel)*chvol[ch]*pgmvol[ch])>>3;
			truekey=key;
			if (ch==9){
				if ((key>=27)&&(key<=87)) {
					env[ch]=envno[drum[key-27][1]];
					truekey=drum[key-27][0];
					v1=v1*drumadj/100;
				}else{
					break;
				}
			}
			if ((v1==0)||(envtbl[env[ch]+1]==0)){
				if (ch==9) break;
				deltatime=noteoff(deltatime,ch,key);
			}else{
				if (pitcpx[ch]) truekey=57+(truekey-57)/2;
				truekey+=shift[ch];
				if ((truekey<4)||(truekey>126)) break;
				volume=(((v1*vol)>>13)+1)>>1;
				holdflg[ch][key]=0;
				deltatime=portassign(deltatime,ch,key,truekey,volume);
				lastkey[ch]=truekey;
			}
			break;

		  case 0xa0:	/* key pressure */
			getc(fp);	/* ignore */
			break;

		  case 0xb0:	/* control change */
			cmd=key;
			arg=getc(fp);
			if (mask[ch]=='M') break;
			switch (cmd){
			  case 0x01: /* pitch modulation */
				chmodl[ch]=(arg+16)>>5;
				break;
			  case 0x05: /* portament time */
				portamenttime=arg*(basefreq/(intperiod*256))/160;
				break;
			  case 0x06: /* data entry */
				if ((rpch[ch]==0)&&(rpcl[ch]==0)){ /* pitch bend depth */
					bendrange[ch]=min(arg,24)*4;
				}
				break;
			  case 0x07: /* channel volume */
				chvol[ch]=arg;
				break;
			  case 0x0b: /* channel expression */
				chexp[ch]=arg;
				deltatime=realexp(deltatime,ch);
				break;
			  case 0x40: /* hold 1 (dumper pedal) */
				if (arg<0x40){
					hold[ch]=0;
					deltatime=dumperoff(deltatime,ch);
				}else{
					hold[ch]=1;
				}
				break;
			  case 0x41: /* portament on/off */
				if (arg<0x40){
					portament[ch]=0;
				}else{
					portament[ch]=portamenttime;
				}
				break;
			  case 0x62: /* NRPN LSB */
				rpcl[ch]=-1;
				break;
			  case 0x63: /* NRPN MSB */
				rpch[ch]=-1;
				break;
			  case 0x64: /* RPN LSB */
				rpcl[ch]=arg;
				break;
			  case 0x65: /* RPN MSB */
				rpch[ch]=arg;
				break;
			  case 0x79: /* channel reset */
				portament[ch]=0;
				chmodl[ch]=0;
				chexp[ch]=127;
				deltatime=realexp(deltatime,ch);
				hold[ch]=0;
				deltatime=dumperoff(deltatime,ch);
				pitbend[ch]=0;
				deltatime=realbend(deltatime,ch,0);
				break;
			  case 0x78: /* all note off */
			  case 0x7b:
			  case 0x7c:
			  case 0x7d:
			  case 0x7e:
			  case 0x7f:
				deltatime=allnoteoff(deltatime,ch);
				break;
			}
			break;

		  case 0xc0: /* program change */
			pgm=key;
			if (envoff) break;
			if (ch==9) break;
			env[ch]=envno[pgmtbl[pgm][0]];
			pgmvol[ch]=pgmtbl[pgm][1];
			shift[ch]=pgmtbl[pgm][2];
			pitcpx[ch]=pgmtbl[pgm][3];
			break;

		  case 0xd0:
			break;

		  case 0xe0: /* pitch bend */
			pbl=key;
			pbh=getc(fp);
			if (ch==9) break;
			pb=(pbh<<7)+pbl-8192;
			if (pb>=0) {
				pb=((long)(pb)*bendrange[ch]/4096+1)/2;
			}else{	
				pb=-(((long)(-pb)*bendrange[ch]/4096+1)/2);
			}
			if (pb!=pitbend[ch]){
				pitbend[ch]=pb;
				deltatime=realbend(deltatime,ch,pb);
			}
			break;

		  case 0xF0: /* meta event etc. */
			switch(ch){
			  case 0x0F:	/* 0xFF:metaevent */
				switch (key){
				  case 0x02:
				  case 0x03:
					size=ReadVarLen(fp);
					for (i=0;i<size;i++){
						if (i<255) strbuf[i]=getc(fp);
					}
					strbuf[min(size,255)]=0;
					printf("%s\n",strbuf);
					cnt=0;
					break;
				  case 0x2F: /* end of file */
					fseek(fp,ReadVarLen(fp),SEEK_CUR);
					endmark=1;
					break;
				  case 0x51: /* tempo set */
					if ((size=ReadVarLen(fp))==3){
						send(deltatime,0,127,32);
						deltatime=0;
						tempo=ReadSemiLong(fp);
						temposet(tempo,div);
					}else{
						fseek(fp,size,SEEK_CUR);
					}
					break;
				  default:
					fseek(fp,ReadVarLen(fp),SEEK_CUR);
					break;
				}
				break;
			  case 0x00:	; /* 0xF0 exclusive message */
			  case 0x07:	; /* 0xF7 */
				fseek(fp,-1,SEEK_CUR);
				fseek(fp,ReadVarLen(fp),SEEK_CUR);
				break;
			  default:
				fseek(fp,-1,SEEK_CUR);
			}
			break;
		}
		if (deltatime>=128){
			if (send(deltatime,0,127,32)!=0) return 3;
			deltatime=0;
		}
	}
	if (send(deltatime+16,7,127,63)!=0) return 3;
	if ( FP_OFF(datap) == 0) segn--;
	return 0;
}


/* make tone conversion table */

void maketonetbl(int intper){
	unsigned int	i;
	unsigned long	toneb[48];
	for (i=0;i<48;i++){
		toneb[i]=tonebase[i]/(basefreq/intper);
	}
	for (i=0;i<512;i++){
			settable(i,(unsigned int) (toneb[(i+keyadj*4)%48]>>(10-((i+keyadj*4)/48))));
	}
}


/* adjust system timer */

void	timeadjust(void){
	unsigned long tm,tm2;

	union {
		union REGS u;
		struct  {
			struct {
				unsigned int l: 4;
				unsigned int h: 4;
			} al,ah,bl,bh,cl,ch,dl,dh;
		} s;
	} r;
	
	do {
		r.u.h.ah = 0x02;
		int86(0x1A, &r.u, &r.u);
	} while(r.u.x.cflag != 0);
	
	tm  =  (unsigned long)(r.s.ch.h) * 36000 +
	       (unsigned long)(r.s.ch.l) * 3600 +
		   (unsigned long)(r.s.cl.h) *  600 +
		   (unsigned long)(r.s.cl.l) *   60 +
		   (unsigned long)(r.s.dh.h) *   10 +
		   (unsigned long)(r.s.dh.l);
	tm   = tm * 1147 / 63;

	tm2 = *(unsigned long *)(0x0040006c);
	*(unsigned long *)(0x0040006c)=tm;
	if (tm2>tm){
		*(unsigned char *)(0x00400070)=1;
		(*(unsigned int *)(0x004000b2))++;
	}
}


/* renew the volume of seq. data buf */

void optvol(int opvol){
	int	key,vol,ch,h,l,i;
	unsigned char far *ptr;
	for (i=0;i<=segn;i++){
		ptr=(unsigned char far*)((unsigned long)(workseg[i])<<16);
		while(1){
			if (((*ptr)&0x80)!=0) ptr++;
			ptr++;
			l=*ptr;
			h=*(ptr+1);
			if ((h==0xff)&&(l==0xff)) break;
			if ((h!=0xff)||(l!=0x00)){
				key=h>>1;
				if (key>=4){
					vol=((h&1)<<5)+(l>>3);
					ch=l&7;
					if (vol!=0) vol=min((vol*opvol+160)/320,63);
					*ptr=(unsigned char)((vol<<3)+ch);
					*(ptr+1)=(unsigned char)((key<<1)+(vol>>5));
				}
			}
			ptr+=2;
		}
	}
}


/* main routione */

void main(int argc,char *argv[]){
	int	i,j,k,l,opt,result,volnum=0,notlx=0,revlev=2;
	int	helpflg=0,parerr=0,opterr=0,keywait=0,pkey,dspoff=0;
	int timadj=1,ispc98=0;
	unsigned int playadr;
	int	optlev=100;					/* optimized volume level (%) */
	FILE *fp;
	char filename[80];
	printf("Beep MIDI Player LXMIDI ver 1.41\n");
	printf("Copyright (C) 1996 HARUYA  all right reserved.\n\n");

	if	(argc==1) helpflg=1;	/* no option */
	for	(opt=1;opt<argc;opt++){
		if ((argv[opt][0]!='-')&&(argv[opt][0]!='/')){
			if (opt!=argc-1) parerr=1;
		}else{
			if (opt==argc-1){
				parerr=1;
				break;
			}
			switch (toupper(argv[opt][1])){
			  case 'A':
				optlev=(unsigned)atol(&argv[opt][2]);
				if ((optlev<10)||(optlev>200)) parerr=1;
				break;
			  case 'C':
				intperiod=(unsigned)atol(&argv[opt][2]);
				if ((intperiod<40)||(intperiod>255)) parerr=1;
				break;
			  case 'K':
				keywait=1;
				break;
			  case 'X':
				dspoff=1;
				break;
			  case 'O':
				portmax=(unsigned)atol(&argv[opt][2])-1;
				if ((portmax!=7)&&(portmax!=11)&&(portmax!=15)) parerr=1;
				break;
			  case 'R':
				keyadj=(unsigned)atol(&argv[opt][2]);
				if ((keyadj<-24)||(keyadj>24)) parerr=1;
				break;
			  case 'E':
				revlev=(unsigned)atol(&argv[opt][2]);
				if ((revlev<1)||(revlev>6)) parerr=1;
				break;
			  case 'T':
				tmpadj=(unsigned)atol(&argv[opt][2]);
				if ((tmpadj<10)||(tmpadj>1000)) parerr=1;
				break;
			  case 'P':
				envoff=1;
				for (i=0;i<16;i++){
					env[i]=ENV9;	/* flat envelope */
				}
				break;
			  case 'V':
				volnum=(unsigned)atol(&argv[opt][2]);
				if ((volnum<0)||(volnum>100)) parerr=1;
				break;
			  case 'D':
				drumadj=(unsigned)atol(&argv[opt][2]);
				if ((drumadj<0)||(drumadj>400)) parerr=1;
				break;
			  case 'N':
				switch (atol(&argv[opt][2])){
				  case  9:		/* for PC-98 */
					ispc98=1;
					timadj=0;
					notlx=1;
					if ((*(char far *)(0x00000501))&0x80){
						basefreq=1996800;
						intperiod=90;
					}else{
						basefreq=2457600;
						intperiod=111;
					}
					break;
				  case	4:		/* for 40MHz LX */
					basefreq=1506847;
					intperiod=70;
					break;
				  case	3:		/* for 32MHz LX */
					basefreq=1205480;
					intperiod=64;
					break;
				  case	2:		/* for IBM-PC (Clock adjust disable */
				    timadj=0;
				  case  5:		/* for IBMPC (Clock adjust enable) */
					notlx=1;
				  case	1:		/* for 31MHz & 15MHz(Normal) LX */
					basefreq=1193180;
					intperiod=64;
					break;
				  case	0:		/* for 36MHz LX */
					break;
				  default:
					parerr=1;
				}
				break;
			  case 'M':
				for(i=0;i<16;i++){
					mask[i]=' ';
				}
				i=2;
				while((j=toupper(argv[opt][i]))!=0){
					if ((j<'0')||(j>'F')) parerr=1;
					if ((j>'9')&&(j<'A')) parerr=1;
					if (j>='A') j=j-'A'+'9'+1;
					j=(j-'0')&0x0f;
					mask[j]='M';
					i++;
				}
				break;
			  default:
				opterr=1;
			}
		}

	}
	opt--;
	if (opterr!=0){
		printf("Illegal option!\n");
		helpflg=1;
	}
	if (parerr!=0){
		printf("Illegal option parameter!\n");
		helpflg=1;
	}
	if (helpflg!=0){
		printf("Usage:LXMIDI [option(s)] filename[.MID]\n\n");
		printf("options:\n");
		printf("  -N[0|1|2|9]     machine   0:18M LX(default) 1:W Spd./Norm. LX 2:IBMPC 9:PC98\n");
		printf("  -C[ 40 ~ 255 ]  interrupt cycle (default:95(-N0) 64(-N1,-N2) 90/111(-N9))\n");
		printf("  -D[  0 ~  400]  percussion volume ([%])\n");
		printf("  -E[  1 ~    6]  reverb level (-6*n [dB])\n");
		printf("  -K              wait keyin before playing.\n");
		printf("  -M[012....DEF]  mask    MIDI channel        \n");
		printf("  -O[8|12|16]     number of maximum polyphony \n");
		printf("  -P              ignore  MIDI program change \n");
		printf("  -R[-24 ~   24]  transpose (by half tone)\n");
		printf("  -T[ 10 ~ 1000]  tempo adjust (%)\n");
		printf("  -V[  0 ~ 100 ]  volume   (0:auto optimize)\n");
		printf("  -A[ 10 ~ 200 ]  optimized volume level (%)\n");
		printf("  -X              turn off LCD display \n");
		printf("\ndefault option:-N0 -O12 -C95 -D100 -E2 -R0 -T100 -V0 -A100\n");
		exit(-1);
	}
	if (notlx) dspoff=0;
	i=0;
	k=1;
	while (((j=argv[opt][i])!=0)&&(i<70)){
		filename[i++]=j;
		if (j=='.') k=0;
	}
	if (k){
		filename[i++]='.';
		filename[i++]='M';
		filename[i++]='I';
		filename[i++]='D';
	}
	filename[i]=0;

	if ((fp=fopen(filename,"rb"))==NULL){
		printf("Can't open %s\n",filename);
		exit(-1);
	}
	printf("%s\n",filename);
	
	if ((segnmax=getmem())==0){
		printf("Insufficient memory\n");
		exit(-1);
	}
	
	segnmax--;
	if (volnum==0){
		vol=32;
	}else{
		vol=(long)(intperiod)*volnum/100;
	}
	segn=0;
	datap=(unsigned char far*)((unsigned long)(workseg[segn])<<16); /* data buf ptr. */
	lfo=(basefreq/intperiod)/128/7;

	result=smfconv(fp);
	fclose(fp);
	switch(result){
		case 0:
			printf("\nSMF analysis completed.\n");
			printf("Data size:%lu bytes.\n",(unsigned long)(segn)*65523+FP_OFF(datap));
			if (volnum==0){
				printf("Optimizing volume...");
				k=1<<revlev;
				l=min( ((long)(intperiod)*320*k*optlev)/((long)(k+1)*peakvol*100),630);
				optvol(l);
				printf("done! Setting volume to %d.\n",l*10/intperiod);
			}
			if (keywait){
				printf("Push any key to start playing.\r");
				while(mykbhit()==0);
				mygetch();
			}
			printf("Start playing...\n");
			playadr=0x0000;
			i=0;
			maketonetbl(intperiod);
			if (ispc98) pc98patch();
			while(1){
				printf("Push [CTRL]/[ALT] to stop,or [SHIFT] to pause.\r");
				if (dspoff) displayoff();
				if (ispc98){
					pcmstart98(intperiod,portmax+1);
				}else{
					pcmstart(intperiod,notlx,portmax+1);
				}
				while(i<=segn){
					if ((pkey=playseq(&playadr,workseg[i],revlev))!=0) break;
					playadr=0x0000;
					i++;
				}
				waitempty();
				if (ispc98){
					pcmstop98();
				}else{
					pcmstop(notlx);
				}
				if (dspoff) displayon();
				if ((pkey&3)==0) break;
				while(mykbhit())	mygetch();
				printf("Paused.  Hit any key to restart playing!      \r");
				while(mykbhit()==0);
				mygetch();
			}
			printf("\n");
			if (timadj) timeadjust();
			break;
		case 1:
			printf("Not standard MIDI file!\n");
			break;
		case 2:
			printf("Not format0 MIDI file!  Please convert to format0.\n");
			break;
		case 3:
			printf("Memory full!\n");
			break;
		case 4:
			break;
		case 5:
			printf("Broken file! (EOF runaway!)\n");
			break;
		}
	relmem();
	exit(result);
}
